<?php

class IAction {

	// Predefined parameter 'action'
	function method() {
		require_once 'common/CGI.class.php';
		$mAction = cgi::param('action', '');
		return is_array($mAction) ? array_shift(array_keys($mAction)) : $mAction;
	}

	// Predefined parameter 'data'
	function &arguments($sScope = null) {

		require_once 'common/CGI.class.php';
		$mParam =& cgi::param('data', array());
		if (is_null($sScope))
			return $mParam;
		elseif (array_key_exists($sScope, $mParam))
			return $mParam[$sScope];
		else
			return array();
	}

	/**
	 * Forward to the specified destination.
	 *
	 *           GET  
	 *       (:)   URL  
	 *   .
	 *
	 *            
	 *    URL .
	 *
	 * @access	public
	 * @param	array	$option
	 * @param	string	$option['uri']
	 * @param	array	$option['session']	optional
	 * @param	array	$option['query']	optional
	 */
	function forward($option) {

		$aParam = array();
		if (array_key_exists('query', $option) && sizeOf($option['query']) != 0) {
			$aParam = $option['query'];
		}
		if (array_key_exists('session', $option) && sizeOf($option['session']) != 0) {
			require_once 'common/Action/ISession.class.php';
			ISession::set($option['session']);
			$aParam = array_merge(ISession::getParam(), $aParam);
		}

		require_once 'common/CGI.class.php';
		cgi::redirect(array('-url' => $option['uri'], '-param' => $aParam));
	}

}

?>
