<?php

class IError {

    /**
     * @access public
     * @param  string           $name
     * @param  mixed   optional $property
     * @return boolean
     */
	function hasError($sForm, $mProperty = null) {
		$aErrors = & IError::_load($sForm);

		if (is_null($mProperty))
			return ( 0 == sizeof($aErrors) );
		elseif (is_array($mProperty)) {
			foreach( $mProperty as $sKey )
				if(array_key_exists($sKey,$aErrors))
					return true;
			return false;
		}
		elseif (is_string($mProperty))
			return array_key_exists($mProperty,$aErrors);

		return false;
	}

    /**
     * @access public
	 *
     * @param  string           $name
     * @param  mixed   optional $property
	 *
     * @return object
     * @return array
     */
	function getError($sForm, $mProperty = null) {
		$aErrors = & IError::_load($sForm);

		if ( is_null($mProperty) )
			return array_values($aErrors);
		elseif( is_array($mProperty) ) {
			$aRes = array();
			foreach ($mProperty as $sKey)
				if ( array_key_exists($sKey,$aErrors) )
					$aRes[] = $aErrors[$sKey];
			return $aRes;
		}
		elseif(array_key_exists($mProperty,$aErrors))
			return $aErrors[$mProperty];
		else
			return null;
	}

    /**
     * @access public
     * @param  string  $name
     * @param  string  $property
     * @return string
     */
	function getMessage($sForm, $mProperty) {
		$mError = & IError::getError($sForm, $mProperty);
		if ( is_array($mError) and $mError )
			$mError =  $mError[0];

		require_once 'common/Action/IMessage.class.php';
		return IMessage::format($mError->getKey(), $mError->getValues());
	}

	function &_load($sForm) {
		static $aErrors;

		if (! isSet($aErrors)) {
			require_once 'common/Action/ISession.class.php';
			if (ISession::has(IError::name($sForm))) {
				$aErrors = ISession::get(IError::name($sForm));
				if (! is_array($aErrors))
					$aErrors = array();

			} else {
				$aErrors = array();
			}
		}
		return $aErrors;
	}

	function name($sName) {
		return $sName . '.error';
	}

}

?>
